﻿using System;
using System.Text;
using System.Windows.Forms;
using System.CodeDom.Compiler;
using System.Reflection;


namespace CalculatorCS
{
  public partial class Form1 : Form
  {
    string[,] btnArray = { { "(", ")", "C", "DEL" }, { "7", "8", "9", "+" }, { "4", "5", "6", "x" }, { "1", "2", "3", "-" }, { "0", ".", "=", "÷" } };
    string strDisplay = "";

    public Form1()
    {
      int baseX;
      int baseY;
      int btnWidth;
      int btnHeight;

      InitializeComponent();

      baseX = MainPanel.Left; ;
      baseY = MainPanel.Top;
      btnWidth = (MainPanel.Width / 4) - 10;
      btnHeight = (MainPanel.Height / 5) - 10;

      for (int i = 0; i < 5; i++)
      {
        for (int j = 0; j < 4; j++)
        {
          Button b = new Button();
          if (isNumeric(btnArray[i, j]))
          {
            b.BackColor = System.Drawing.Color.FromArgb(0xEDD9DF);
          }
          b.Height = btnHeight;
          b.Width = btnWidth;
          b.Top = baseY + (btnHeight * i);
          b.Left = baseX + (btnWidth * j);
          b.Name = String.Format("btnID{0}", 5 * i + j);
          b.Text = btnArray[i, j];
          b.Click += new EventHandler(btn_Click);
          MainPanel.Controls.Add(b);
        }
      }
    }

    private void btn_Click(object sender, EventArgs e)
    {
      string s = (sender as Button).Text;
      if (strDisplay == "error")
      {
        strDisplay = "";
      }
      if (s == "DEL")
      {
        if (strDisplay.Length > 0)
        {
          strDisplay = strDisplay.Substring(0, strDisplay.Length - 1);
        }
      }
      else if (s == "C")
      {
        strDisplay = "";
      }
      else if (s == "=")
      {
        strDisplay = Eval(strDisplay);
      }
      else
      {
        strDisplay += s;
      }
      this.txtDisplay.Text = strDisplay;
    }

    private bool isNumeric(string s)
    {
      return int.TryParse(s, out int n);
    }

    private string Eval(string sExpression)
    {
      string result = "error";
      CodeDomProvider c = CodeDomProvider.CreateProvider("CSharp");
      CompilerParameters cp = new CompilerParameters();

      // replace arithmetic symbols with valid ones
      sExpression = sExpression.Replace("x", "*");
      sExpression = sExpression.Replace("÷", "/");

      cp.ReferencedAssemblies.Add("system.dll");

      cp.CompilerOptions = "/t:library";
      cp.GenerateInMemory = true;

      StringBuilder sb = new StringBuilder("");
      sb.Append("using System;\n");

      sb.Append("namespace CSCodeEvaler{ \n");
      sb.Append("public class CSCodeEvaler{ \n");
      sb.Append("public object EvalCode(){\n");
      sb.Append("return " + sExpression + "; \n");
      sb.Append("} \n");
      sb.Append("} \n");
      sb.Append("}\n");

      CompilerResults cr = c.CompileAssemblyFromSource(cp, sb.ToString());
      if (cr.Errors.Count == 0)
      {
        System.Reflection.Assembly a = cr.CompiledAssembly;
        object o = a.CreateInstance("CSCodeEvaler.CSCodeEvaler");

        Type t = o.GetType();
        MethodInfo mi = t.GetMethod("EvalCode");

        object s = mi.Invoke(o, null);
        result = s.ToString();
      }
      return result;
    }
  }
}
